display "com: Outputs in the appendix:";
$ontext
Time-stamp: 	<2012-12-06 19:49:28 >
Author: 	Shiro Takeda
First-written:	<2006/06/23>
$offtext

*	----------------------------------------------------------------------
*	Summary indices:

*	Level parameters:
l_vxwd("c",t,r,s) = pfob0(t,r,s)*pfob.l(t,r,s)*qxs0(t,r,s)*qxs.l(t,r,s);
l_vst("c",m,r) = pm0(m,r)*pm.l(m,r)*qst0(m,r)*qst.l(m,r);
l_vxw("c",t,r)$m(t) = sum(s, l_vxwd("c",t,r,s)) + l_vst("c",t,r);
l_vxw("c",t,r)$nm(t) = sum(s, l_vxwd("c",t,r,s));
l_vxwregion("c",r) = sum(t, l_vxw("c",t,r));
l_viws("c",t,s,r) = pcif0(t,s,r)*pcif.l(t,s,r)*qxs0(t,s,r)*qxs.l(t,s,r);
l_viw("c",t,s) = sum(r, l_viws("c",t,r,s));
l_viwregion("c",r) = sum(t, l_viw("c",t,r));

l_vga("c",t,r) = pg0(t,r)*pg.l(t,r)*qg0(t,r)*qg.l(t,r);
l_vpa("c",t,r) = pp0(t,r)*pp.l(t,r)*qp0(t,r)*qp.l(t,r);
l_reginv("c",r) = pcgds0(r)*pcgds.l(r)*qcgds0(r)*qcgds.l(r);
l_gdp("c",r)
    = sum(t$VGA(t,r), pg0(t,r)*pg.l(t,r)*qg0(t,r)*qg.l(t,r))
    + sum(t$VPA(t,r), pp0(t,r)*pp.l(t,r)*qp0(t,r)*qp.l(t,r))
    + pcgds0(r)*pcgds.l(r)*qcgds0(r)*qcgds.l(r)
    + sum((t,s)$VXWD(t,r,s),
    pfob0(t,r,s)*pfob.l(t,r,s)*qxs0(t,r,s)*qxs.l(t,r,s))
    + sum(m$VST(m,r), pm0(m,r)*pm.l(m,r)*qst0(m,r)*qst.l(m,r))
    - sum((t,s)$VIWS(t,s,r),
    pcif0(t,s,r)*pcif.l(t,s,r)*qxs0(t,s,r)*qxs.l(t,s,r));

*	Share parameters:
sh_cons("c",t,r) = vconshr0(t,r) * vconshr.l(t,r);
sh_vxwd_vxwregion("c",t,r,s) = l_vxwd("c",t,r,s)/l_vxwregion("c",r);
sh_vst_vxwregion("c",m,r) = l_vst("c",m,r)/l_vxwregion("c",r);
sh_viws_viwregion("c",t,s,r) = l_viws("c",t,s,r)/l_viwregion("c",r);

sh_vga_gdp("c",t,r) = l_vga("c",t,r)/l_gdp("c",r);
sh_vpa_gdp("c",t,r) = l_vpa("c",t,r)/l_gdp("c",r);
sh_reginv_gdp("c",r) = l_reginv("c",r)/l_gdp("c",r);
sh_vxwd_gdp("c",t,r,s) = l_vxwd("c",t,r,s)/l_gdp("c",r);
sh_vst_gdp("c",m,r) = l_vst("c",m,r)/l_gdp("c",r);
sh_viws_gdp("c",t,s,r) = l_viws("c",t,s,r)/l_gdp("c",r);

*	Summary indices:
psw(r) =
    prod((t,s)$VXWD(t,r,s),
	pfob.l(t,r,s)**(sum(b_c, 0.5 * sh_vxwd_vxwregion(b_c,t,r,s))))
    * prod(m$VST(m,r),
	pm.l(m,r)**(sum(b_c, 0.5 * sh_vst_vxwregion(b_c,m,r))));
pdw(r) = prod((t,s)$VIWS(t,s,r),
    pcif.l(t,s,r)**(sum(b_c, 0.5 * sh_viws_viwregion(b_c,t,s,r))));
tot(r) = psw(r) / pdw(r);

vgdp(r) = l_gdp("c",r) / l_gdp("b",r);

*	GDP price index is defined as Tornqvist price index.
pgdp(r) =
    prod(t$VGA(t,r),
	pg.l(t,r)**(sum(b_c, 0.5 * sh_vga_gdp(b_c,t,r))))
    * prod(t$VPA(t,r),
	pp.l(t,r)**(sum(b_c, 0.5 * sh_vpa_gdp(b_c,t,r))))
    * pcgds.l(r)**(sum(b_c, 0.5 * sh_reginv_gdp(b_c,r)))
    * prod((t,s)$VXWD(t,r,s),
	pfob.l(t,r,s)**(sum(b_c, 0.5 * sh_vxwd_gdp(b_c,t,r,s))))
    * prod(m$VST(m,r),
	pm.l(m,r)**(sum(b_c, 0.5 * sh_vst_gdp(b_c,m,r))))
    * prod((t,s)$VIWS(t,s,r),
	pcif.l(t,s,r)**(- sum(b_c, 0.5 * sh_viws_gdp(b_c,t,s,r))));

qgdp(r) = vgdp(r) / pgdp(r);

*	----------------------------------------------------------------------
*	Percentage changes:
* display "com: -- Percentage changes";

pc_psw(r) = 100 * (psw(r) - 1);
pc_pdw(r) = 100 * (pdw(r) - 1);
pc_tot(r) = 100 * (tot(r) - 1);
pc_vgdp(r) = 100 * (vgdp(r) - 1);
pc_pgdp(r) = 100 * (pgdp(r) - 1);
pc_qgdp(r) = 100 * (qgdp(r) - 1);

display "com: -- Summary indices:";

* display l_vxwd, l_vst, l_vxw, l_vxw, l_vxwregion, l_viws, l_viw, l_viwregion,
* 	l_vga, l_vpa, l_reginv, l_gdp;
* display sh_cons, sh_vxwd_vxwregion, sh_vst_vxwregion, sh_viws_viwregion;
* display sh_vga_gdp, sh_vpa_gdp, sh_reginv_gdp, sh_vxwd_gdp, sh_vxwd_gdp,
* 	sh_viws_gdp; ;
display pc_tot, pc_vgdp, pc_pgdp, pc_qgdp;

*	----------------------------------------------------------------------
*	Calculation of equivalent variation:
display "com: -- Calculation of equivalent variation:";

ug_ev.l(r) = 1;
qg_ev.l(t,r) = 1;
up_ev.l(r) = 1;
uepriv_ev.l(r) = 1;
vconshr_ev.l(t,r) = 1;
qp_ev.l(t,r) = 1;
uelas_ev.l(r) = 1;
yp_ev.l(r) = 1;
yg_ev.l(r) = 1;
qsave_ev.l(r) = 1;
y_ev.l(r) = 1;
u_ev.fx(r) = u.l(r);

option solprint = off;
solve ev_calc using mcp;
option solprint = on;

EV(r) = (1/scale_factor) * (y0(r) * y_ev.l(r) - y0(r));
EV("World") = sum(r, EV(r));

display EV;

* --------------------
* Local Variables:
* mode: gams
* fill-column: 80
* End:
