$ontext
Time-stamp: 	<2012-12-06 19:49:46 >
Author: 	Shiro Takeda
First-written:	<2006/06/22>

Benchmark replication and clean up calculation.

$offtext
*	----------------------------------------------------------------------
*	Benchmark replication.
display "com: Benchmark replication.";

putclose titlemaker
   '@title Experiment name = %exp_name%, Benchmark replication';
execute '.\%exp_name%_titlemaker.cmd';

if(%fl_debug%,
    option solprint = on;
    else
    option solprint = off;
);
if(%solver_mcp%,
    gtap_mcp.iterlim = 0;
    solve gtap_mcp using mcp;
    else
    gtap_nlp.iterlim = 0;
    solve gtap_nlp using nlp minimizing dummy_objective;
);
option solprint = on;
$if not %bench_rep_only% == "0" $setglobal skip_shock 1
$if not %bench_rep_only% == "0" $goto end_of_this_file

gtap_mcp.iterlim = 9000;
gtap_nlp.iterlim = 9000;

*	----------------------------------------------------------------------
*	Cleanup calculation.
display "com: Cleanup calculation.";

putclose titlemaker
   '@title Experiment name = %exp_name%, Cleanup calculation';
execute '.\%exp_name%_titlemaker.cmd';

if(%fl_debug%,
    option solprint = on;
    else
    option solprint = off;
);
if(%solver_mcp%,
    solve gtap_mcp using mcp;
    else
    solve gtap_nlp using nlp minimizing dummy_objective;
);

option solprint = on;
$if not %clean_up_only% == "0" $setglobal skip_shock 1

* $include gtap_output_results.gms

$label end_of_this_file

* --------------------
* Local Variables:
* mode: gams
* fill-column: 80
* End:
